precision highp float;

uniform sampler2D texture;
varying vec2 txCoord;

const float bluramount  = 2.5;
const float stepSize    = 0.001;
const float steps       = 6.8;

const float minOffs     = (float(steps-1.0)) / - 1.75;
const float maxOffs     = (float(steps-1.0)) / + 1.75;

void main() {

    float amount;
    vec4 blurred;

    blurred = vec4(0.0, 0.0, 0.0, 1.0);

    for (float offsX = minOffs; offsX <= maxOffs; ++offsX) {
        for (float offsY = minOffs; offsY <= maxOffs; ++offsY) {

            vec2 temp_tcoord = txCoord.xy;
            temp_tcoord.x += offsX * bluramount * stepSize;
            temp_tcoord.y += offsY * bluramount * stepSize;

            blurred += texture2D(texture, temp_tcoord);

        }
    }

    blurred /= float(steps * steps);

	vec3 colorContrasted = blurred.rgb * 1.2;
	vec3 bright = colorContrasted + vec3(-.35, -.35, -.35);
	gl_FragColor.rgb = bright;
	gl_FragColor.a = 1.;

}
