precision highp float;

uniform sampler2D texture;
varying vec2 txCoord;

void main() {
    vec2 uv = txCoord.xy;
    vec4 c[4];
    c[0] = texture2D(texture, uv);
    c[1] = texture2D(texture, vec2(1.0 - uv.x, uv.y));
    c[2] = texture2D(texture, vec2(uv.x, 1.0 - uv.y));
    c[3] = texture2D(texture, vec2(1.0 - uv.x, 1.0 - uv.y));
    
    vec4 color = (uv.y >= 0.5 && uv.x >= 0.5) ? c[0] :
    	(uv.y >= 0.5 && uv.x < 0.5) ? c[1] :
    	(uv.y < 0.5 && uv.x >= 0.5) ? c[2] : c[3];
    
    gl_FragColor = color;
}
